/******************************/
/* FIGHTING INTELLIGENT FIRES */
/* Pawel Pralat (13-May-2010) */
/******************************/

#include <stdio.h>
#include <math.h>

double eps = 0.000000001;   // precision

int check_x(double x, int d, int k)
{
  double y_min=0;
  double y_max=k*x*d-eps;
  double y=y_max/2;
  double z;

  while (y_max-y_min>eps)
    {
      y=(y_max+y_min)/2;

      double z_min=0;
      double z_max=(1-(k+1)*x)*d-eps;
      z=z_max/2;
      while (z_max-z_min>eps)
	{
	  z=(z_max+z_min)/2;

          if (z*z/((1-(k+1)*x)*d-z)>y*y/(k*x*d-y))
	    z_max = z;
	  else
	    z_min = z;
	}
      
      if (y*y/(k*x*d-y)>d*x-y-z)
	y_max = y;
      else 
	y_min = y;
    }

  double f = k*x*(d-1)*log(k) + (k+1)*x*(d-1)*log(x) + d*log(d)/2.0 + (1-(k+1)*x)*(d-1)*log(1-(k+1)*x) - y*log(y) - z*log(z) - (k*x*d-y)*log(k*x*d-y)/2.0 - (x*d-y-z)*log(x*d-y-z)/2.0 - ((1-(k+1)*x)*d-z)*log((1-(k+1)*x)*d-z)/2.0;

  if (f>0)
    return 0;
  else
    return 1;
}

int main()
{
  int d, k;
  printf("k = ");
  scanf("%d",&k);

  printf("[d,numerical upper bound,theoretical upper bound]\n");

  for (d = 3 ; d <= 200 ; d++)
    {
      double x_min = 0;
      double x_max = 1.0/(k+1)-eps;
      double x;
      while (x_max - x_min > eps)
	{
	  x=(x_min+x_max)/2.0;
	  if (check_x(x,d,k))
	    x_min=x;
	  else
	    x_max=x;
	}

      double l = 2*sqrt(d-1);
      double old = (1+l*(sqrt(k)+d/(d-l))/d)/(k+1);
      
      printf("[%d,%f,%f],",d,1-k*x,old);
    }
  return 0;
}
